(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["ReactDomWalker"] = factory();
	else
		root["ReactDomWalker"] = factory();
})(window, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "./src/index.js");
/******/ })
/************************************************************************/
/******/ ({

/***/ "./src/index.js":
/*!**********************!*\
  !*** ./src/index.js ***!
  \**********************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.isEmpty = isEmpty;
exports.isSimple = isSimple;
exports.getChildren = getChildren;
exports.getChildrenFromChild = getChildrenFromChild;
exports.getChildrenFromProps = getChildrenFromProps;
exports.getDisplayName = getDisplayName;
exports.getDomNode = getDomNode;
exports.getInstance = getInstance;
exports.getRoot = getRoot;
exports.findRoots = findRoots;
exports.walk = walk;
exports.json = json;
function isEmpty(node) {
  return node == null;
}

function isSimple(node) {
  return typeof node === "boolean" || typeof node === "number" || typeof node === "string";
}

function getChildren(node) {
  if (node.child) {
    return getChildrenFromChild(node.child);
  } else if (node.memoizedProps) {
    return getChildrenFromProps(node.memoizedProps);
  } else if (node.props) {
    return getChildrenFromProps(node.props);
  }
  return [];
}

function getChildrenFromChild(node) {
  var children = [];
  while (node) {
    children.push(node);
    node = node.sibling;
  }
  return children;
}

function getChildrenFromProps(props) {
  return Array.isArray(props.children) ? props.children : [props.children];
}

function getDisplayName(node) {
  if (!node.type) {
    return null;
  }
  if (typeof node.type === "string") {
    return node.type;
  }
  return node.type.displayName || node.type.name || "[anonymous]";
}

function getDomNode(node) {
  var stateNode = node.stateNode;

  return stateNode && stateNode.tagName ? stateNode : null;
}

function getInstance(node) {
  for (var key in node) {
    if (key.indexOf("__reactInternalInstance") === 0) {
      return node[key];
    }
  }
}

function getRoot(node) {
  return node._reactRootContainer && node._reactRootContainer._internalRoot.current;
}

function findRoots(node) {
  var roots = [];
  var tree = document.createTreeWalker(node);
  while (tree.nextNode()) {
    var root = getRoot(tree.currentNode);
    if (root) {
      roots.push(root);
    }
  }
  return roots;
}

function walk(root, call) {
  // Skip empty nodes.
  if (isEmpty(root)) return;

  // Allow returning false to throw out the inclusive tree.
  if (call(root) === false) return;

  // Recursively walk children.
  getChildren(root).forEach(function (node) {
    // We add the parent node so we can look up in the tree if need be.
    if (!isEmpty(node) && (typeof node === "undefined" ? "undefined" : _typeof(node)) === "object") {
      node.parent = root;
    }
    walk(node, call);
  });
}

function json(node) {
  // Return empty and simple nodes.
  if (isEmpty(node) || isSimple(node)) {
    return node;
  }

  // Memoized props may also be simple, but we don't return if they're empty.
  if (isSimple(node.memoizedProps)) {
    return node.memoizedProps;
  }

  // In the last case we generate data for the corresponding React node.
  return {
    children: getChildren(node).map(json),
    name: getDisplayName(node)
  };
}

/***/ })

/******/ });
});
//# sourceMappingURL=index.js.map